Форум программистов, компьютерный форум CyberForum.ru

try-catch - C++

Восстановить пароль Регистрация
 
yoghurt92
373 / 344 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
24.01.2013, 14:34     try-catch #1
Доброго времени суток, начал изучать исключения, и вот есть такой код:

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    else if(num2 == 0)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
А потом захотел сделать несколько блоков catch чтобы посмотреть как это все работает, но получил сам ошибку...

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        DivideByZeroError(int _num):message(L"Деление на нуль!"), num(_num) {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    if(num2 == 0)
        throw DivideByZeroError(num2);
    else if(num2 == 1)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    catch(DivideByZeroError error1(number2)) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error1.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
и вот что вылезло...

C++
1
2
 error C2061: syntax error : identifier 'number2'
 error C2228: left of '.printMessage' must have class/struct/union
Заранее благодарю за помощь!
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
24.01.2013, 14:34     try-catch
Посмотрите здесь:

C++ try-catch
try catch C++
C++ try-catch
C++ TRY/CATCH
C++ try . catch
После регистрации реклама в сообщениях будет скрыта и будут доступны все возможности форума.
Toshkarik
 Аватар для Toshkarik
1139 / 856 / 50
Регистрация: 03.08.2011
Сообщений: 2,381
Завершенные тесты: 1
24.01.2013, 14:51     try-catch #2
Цитата Сообщение от yoghurt92 Посмотреть сообщение
catch(DivideByZeroError error1(number2))
Вы где такое вообще вычитали? Это не верный синтаксис.

Добавлено через 5 минут
Вы видать не понимаете принцип работы исключений. В блоках catch "ловятся" объекты классов исключений. По аналогии можно привести функцию, которая принимает в качестве параметра некий объект, catch блок, точно так же, принимает объект исключения. Причем лучше его принимать по ссылке.
C++
1
catch(DivideByZeroError &error)
yoghurt92
373 / 344 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
24.01.2013, 14:55  [ТС]     try-catch #3
Toshkarik, спасибо, так а как тогда должен выглядеть следующий блок catch?
Toshkarik
 Аватар для Toshkarik
1139 / 856 / 50
Регистрация: 03.08.2011
Сообщений: 2,381
Завершенные тесты: 1
24.01.2013, 15:04     try-catch #4
yoghurt92, блоки catch нужны для каждого типа исключения, которое нужно поймать. Функция ведь не обязательно выбрасывает одно исключение.
Например, создадим новый класс исключения:

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class OutOfRange {
 public:
   OutOfRange( std::wstring &str = L"Out of range" )
      : error( str )
   {
      
   }
 
   const std::wstring &getMessage() const {
      return error;
   }
 
 private:
   std::wstring error;
};
И добавим его в функцию для ограничения диапазона чисел:

C++
1
2
3
4
5
6
7
8
9
10
float quotient( int num1, int num2 )
{
    if ( num2 == 0 )
        throw DivideByZeroError();
 
    if ( num1 > 1000 || num2 > 2000 )
        throw OutOfRange();
 
    return (float) num1 / num2;
}
Тогда уже можно добавить второй catch блок:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
    catch(OutOfRange &error) {//обработчик ошибки
        wcout << L"ОШИБКА!: " << error1.getMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
В классе DivideByZero переменная num лишняя.
yoghurt92
373 / 344 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
24.01.2013, 15:08  [ТС]     try-catch #5
Toshkarik, спасибо, разобрался)
Yandex
Объявления
24.01.2013, 15:08     try-catch
Ответ Создать тему
Опции темы

Текущее время: 00:33. Часовой пояс GMT +3.
КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2016, vBulletin Solutions, Inc.
Рейтинг@Mail.ru